package com.fp.persistence.parmas.soli;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TARMAGENCIAARMA*/
@Embeddable
public class TarmAgenciaArmaKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="CARMA", nullable=false,updatable=false)

/**
* PK del arma asociada a la agencia
*/
private String carma;

@Column(name="CAGENCIA", nullable=false,updatable=false)

/**
* PK de la agencia asociada al arma
*/
private Long cagencia;

/**Contructor por defecto*/
public TarmAgenciaArmaKey(){}
/**Contructor de TarmAgenciaArmaKey
@param pCarma PK del arma asociada a la agencia
@param pCagencia PK de la agencia asociada al arma
*/
public TarmAgenciaArmaKey(String pCarma,Long pCagencia){
 carma=pCarma;
 cagencia=pCagencia;
}
/**Obtiene el valor de carma
@return valor de carma*/
public String getCarma(){
  return carma;
}
/**Fija el valor de carma
@param pCarma nuevo Valor de carma*/
public void setCarma(String pCarma){
  carma=pCarma;
}

/**Obtiene el valor de cagencia
@return valor de cagencia*/
public Long getCagencia(){
  return cagencia;
}
/**Fija el valor de cagencia
@param pCagencia nuevo Valor de cagencia*/
public void setCagencia(Long pCagencia){
  cagencia=pCagencia;
}

/**Implementacion de la comparacion de TarmAgenciaArmaKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TarmAgenciaArmaKey))return false;
  TarmAgenciaArmaKey that = (TarmAgenciaArmaKey) o;
  if (this.getCarma() == null || that.getCarma() == null){
      return false;
  }
  if (! this.getCarma().equals(that.getCarma())){
    return false;
  }
  if (this.getCagencia() == null || that.getCagencia() == null){
      return false;
  }
  if (! this.getCagencia().equals(that.getCagencia())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia TarmAgenciaArmaKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getCarma() == null ? 0 : this.getCarma().hashCode());
    result = result * 37 + (this.getCagencia() == null ? 0 : this.getCagencia().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
